#include<cstdio>
#include<iostream>
#include<cstdlib>
#include<fstream>
#include<vector>
using namespace std;

int max(int a,int b) { return (a>b ? a:b); }
int min(int a, int b){ return (a>b ? b:a); }

int n,m;
bool map[2000][2000];

int a,b;

int vertU[2000][2000];
int vertD[2000][2000];
int horL[2000][2000];
int horR[2000][2000];
int solV[2000][2000];
int solH[2000][2000];

int solSumR[2000][2000];
int solSumC[2000][2000];

int getvh() {
     for(int i=0; i<n; i++) {
         int j=0;
         while(j<m) {
              while(j<m && map[i][j]) { horL[i][j]=horR[i][j]=0;j++;  }
              if(j==m) break;
              int j0=j;
              while(j<m && !map[i][j]) j++;
              int j1=j;
              for(int k=j0; k<j1; k++) {
                  horR[i][k]=j1-k;
                  horL[i][k]=1+k-j0;
              }
         }
     }
     for(int j=0 ;j<m; j++) {
         int i=0;
         while(i<n) {
             while(i<n && map[i][j]) { vertU[i][j]=vertD[i][j]=0; i++; }
             if(i==n) break;
             int i0=i;
             while(i<n && !map[i][j]) i++;
             int i1=i;
             for(int k=i0; k<i1; k++) {
                  vertU[k][j]=k-i0+1;
                  vertD[k][j]=i1-k;
             } 
         }
     }
     for(int i=0; i<n; i++)
         for(int j=0; j<m; j++) {
             solH[i][j]=solV[i][j]=0;
             if(horL[i][j]+horR[i][j]>b && horR[i][j]>=1 && horL[i][j]>=1)
                solH[i][j]=min(horL[i][j],b)-max(1,b+1-horR[i][j])+1;
             if(vertU[i][j]+vertD[i][j]>b && vertU[i][j]>=1 && vertD[i][j]>=1) 
                solV[i][j]=min(vertU[i][j],b)-max(1,b+1-vertD[i][j])+1;
         }
     for(int i=0; i<n; i++) {
         solSumR[i][0]=solV[i][0];
         for(int j=1; j<m; j++)
             solSumR[i][j]=solSumR[i][j-1]+solV[i][j];
     }
     for(int j=0; j<m; j++) {
         solSumC[0][j]=solH[0][j];
         for(int i=1; i<n; i++)
             solSumC[i][j]=solSumC[i-1][j]+solH[i][j];
     }
     int max=0;
     
     if(a==1) {
              for(int i=0; i<n; i++)
                 for(int j=0; j<m; j++)
                     if(solH[i][j]+solV[i][j]>=max) max=solH[i][j]+solV[i][j];
     } else {
         for(int i=0; i<n; i++)
             for(int j=0; j<m; j++) {
                 if(j+a-1<m && horR[i][j]>=a) {
                     int tmp=solSumR[i][j+a-1]-(j>=1 ? solSumR[i][j-1] : 0);
                     if(j+horR[i][j]-b>=j-horL[i][j]+1) {
                         tmp+=(horR[i][j]+horL[i][j]-b);
                         if(j-b>=j-horL[i][j]+1) tmp-=(horL[i][j]-b);
                         if(j+a<=j+horR[i][j]-b) tmp-=(horR[i][j]-b-a+1);
                     }
                     if(tmp>max) max=tmp;
                 } 
                 if(i+a-1<n && vertD[i][j]>=a) {
                     int tmp=solSumC[i+a-1][j]-(i>=1 ? solSumR[i-1][j] : 0);
                     if(i+vertD[i][j]-b>=i-vertU[i][j]+1) {
                         tmp+=(vertD[i][j]+vertU[i][j]-b);
                         if(i-b>=i-vertU[i][j]+1) tmp-=(vertU[i][j]-b);
                         if(i+a<=i+vertD[i][j]-b) tmp-=(vertD[i][j]-b-a+1);
                     }
                     if(tmp>max) max=tmp;
                 }
             }
     }
     int totSol=0;
     for(int i=0; i<n; i++)
         for(int j=0; j<m; j++) {
             if(horR[i][j]>=b) totSol++;
             if(vertD[i][j]>=b) totSol++;
         }
     return totSol-max;
}

int main() {
     scanf("%d %d %d %d\n",&n,&m,&a,&b);
     for(int i=0; i<n; i++) {
        string str; getline(cin,str);
        for(int j=0; j<m; j++) {
            map[i][j]=(str[j]=='1');
        }
     }
     printf("%d",getvh());
    return 0;
}