#include <bits/stdc++.h>
using namespace std;
const int MAXN = 200010;
int arr[MAXN];
int n,k;
unordered_map<int,int> index;
void normalize()
{
    vector<int> vals;
    for(int i=0;i<n;i++)
        vals.push_back(arr[i]);
    sort(vals.begin(),vals.end());
    int idx = 2;
    index[vals[0]]=1;
    for(int i=1;i<vals.size();i++)
        if(vals[i]!=vals[i-1]) index[vals[i]]=idx++;
    for(int i=0;i<n;i++) arr[i]=index[arr[i]];
}
vector<int> occ[MAXN];
bool check(int x,int maxOcc)
{
    //printf("Checking %d\n",x);
    for(int i=1;i<=maxOcc;i++)
    {
        for(int j=k;j<occ[i].size();j++)
        {
            int bucketR = occ[i][j]/x;
            int bucketL = occ[i][j-k]/x;
            if(bucketR == bucketL) {
                    //printf("%d-ti i %d-k-ti element occ[%d] su isti\n",j,j-k,i);
                    return false;
            }
        }
    }
    return true;
}
void debug(vector<int> x)
{
    for(int i=0;i<x.size();i++)
        printf("%d ",x[i]);
    printf("\n");
}
int main()
{
    scanf("%d%d",&n,&k);
    for(int i=0;i<n;i++)
        scanf("%d",&arr[i]);
    normalize();
    int maxOcc = 0;
    for(int i=0;i<n;i++)
    {
        occ[arr[i]].push_back(i);
        maxOcc = max(maxOcc, arr[i]);
    }

    vector<int> factors;
    factors.push_back(1);
    factors.push_back(n);
    for(int i=2;i*i<=n;i++)
    {
        if(n%i==0)
        {
            factors.push_back(i);
            if(n/i != i) factors.push_back(n/i);
        }
    }
    sort(factors.begin(),factors.end());
    int sol = 0;
    for(auto p:factors)
        if(check(p,maxOcc)) ++sol;
    /*debug(factors);
    int lo = 0;
    int ans;
    int hi = factors.size()-1;
    while(lo<=hi)
    {
        int mid = (lo+hi)/2;
        if(check(factors[mid],maxOcc))
        {
            ans = mid;
            lo = mid+1;
        }
        else hi = mid -1;
    }*/
    printf("%d\n",sol);
    return 0;
}
/*
12 2
1 2 3 4 2 3 4 2 1 2 3 4
*/