#include <cstdio>
#include <cmath>
#include <vector>
using namespace std;
#define maxN 30000

int n;
int a[maxN];
vector<int> p[maxN];
vector<int> pr;
bool f[100000];

void sieve() {
  int n = 100000;
  int sq = (int)sqrt(n);
  for (int i = 2; i <= sq; i++)
    if (!f[i])
      for (int j = i * i; j < n; j += i)
        f[j] = true;
  for (int i = 2; i < n; i++)
    if (!f[i])
      pr.push_back(i);
}

void dec(int x, int id) {
  for (int i = 0; i < pr.size() && x > 1; i++)
    if (x % pr[i] == 0) {
       while (x % pr[i] == 0)
         x /= pr[i];
       p[id].push_back(pr[i]);
    }
  if (x > 1)
    p[id].push_back(x);
}

bool gcd(int x, int y) {
  int l = 0;
  int r = 0;
  while (l < p[x].size() && r < p[y].size()) {
    if (p[x][l] < p[y][r])
      l++;
    else if (p[x][l] > p[y][r])
      r++;
    else
      return false;
  }
  return true;
}

int main() {
  scanf("%d", &n);
  sieve();
  for (int i = 0; i < n; i++) {
    scanf("%d", &a[i]);
    dec(a[i], i);
  }
  int s = 0;
  for (int i = 0; i < n; i++)
    for (int j = i + 1; j < n; j++)
      if (gcd(i, j))
        s++;
  printf("%d\n", s);
  return 0;
}