#include <cstdio>
#include <vector>
#include <unordered_map>
#include <unordered_set>
using namespace std;

vector<int> ps;
int sito[1000010];
void init()
{
    for(int i = 2; i <= 1000000; i++)
    {
        if (sito[i])
            continue;
        if (i <= 10000)
            ps.push_back(i);
        sito[i] = i;
        for(int w = 2; w*i <= 1000000; w++)
            if (!sito[w*i])
                sito[w*i] = i;
    }
}

vector<int> factor(int x)
{
    vector<int> sol;
    int t = 0;
    while(t < ps.size())
    {
        if (x%ps[t]==0)
        {
            while(x%ps[t]==0)
                x/=ps[t];
            sol.push_back(ps[t]);
        }
        t++;
    }
    if ( x > 1)
    {
        sol.push_back(x);
        return sol;
    }
   /* while(x > 1)
    {
        int p = sito[x];
        while(x % p == 0)
            x/=p;
        sol.push_back(p);
    } */
    return sol;
}

bool inters(vector<int>&a,vector<int>&b)
{
    int i = 0, j = 0;
    while(i < a.size() && j < b.size())
    {
        if (a[i] < b[j])
            i++;
        else if (a[i] > b[j])
            j++;
        else
            return true;
    }
    return false;
}
vector<int> fs[30010];
unordered_map<int,vector<int>> mp;
int s[30010];
int main()
{
    init();
    //printf("%d\n",ps.size());
    int n;
    scanf("%d",&n);
    long long num = 0;
    for(int i = 0; i < n; i++)
    {
        int x;
        scanf("%d",&x);
        fs[i] = factor(x);
        for(auto y : fs[i])
            for(auto w : mp[y])
                s[w] = i;
        int cnt = 0;
        for(int j = 0; j < i; j++)
            if (s[j] == i)
                cnt++;
        if (i > 0)
            num += i-cnt;
        for(auto y : fs[i])
            mp[y].push_back(i);
    }
    printf("%lld\n",num);
    return 0;
}