#include <cstdio>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
using namespace std;

vector<int> ps;
int sito[1000010];
void init()
{
    for(int i = 2; i <= 1000000; i++)
    {
        if (sito[i])
            continue;
        if (i <= 10000)
            ps.push_back(i);
        sito[i] = i;
        for(int w = 2; w*i <= 1000000; w++)
            if (!sito[w*i])
                sito[w*i] = i;
    }
}

vector<int> factor(int x)
{
    vector<int> sol;
    int t = 0;
    while(t < ps.size())
    {
        if (x%ps[t]==0)
        {
            while(x%ps[t]==0)
                x/=ps[t];
            sol.push_back(ps[t]);
        }
        t++;
    }
    if ( x > 1)
    {
        sol.push_back(x);
        return sol;
    }
   /* while(x > 1)
    {
        int p = sito[x];
        while(x % p == 0)
            x/=p;
        sol.push_back(p);
    } */
    return sol;
}

bool inters(vector<int>&a,vector<int>&b)
{
    int i = 0, j = 0;
    while(i < a.size() && j < b.size())
    {
        if (a[i] < b[j])
            i++;
        else if (a[i] > b[j])
            j++;
        else
            return true;
    }
    return false;
}
vector<int> fs[30010];
unordered_map<int,vector<int>> mp;
int s[30010];

int a[30010];
int cnt[30010];
int main()
{
    init();
    //printf("%d\n",ps.size());
    int n;
    scanf("%d",&n);
    for(int i = 0; i < n; i++)
        scanf("%d",&a[i]);
    sort(a,a+n);
    cnt[0] = 1;
    int wq = 0;
    for(int i = 1; i < n; i++)
        if (a[i] == a[i-1])
            cnt[wq]++;
        else
        {
            wq++;
            a[wq] = a[i];
            cnt[wq] = 1;
        }
    n = wq+1;
    long long num = 0;
    int sum = 0;
    for(int i = 0; i < n; i++)
    {
        int x = a[i];
        fs[i] = factor(x);
        int cntx = 0;
        for(auto y : fs[i])
            for(auto w : mp[y])
            {
                if (s[w] < i)
                    cntx+= cnt[w];
                s[w] = i;
            }
        num += cnt[i]*(sum-cntx);
        for(auto y : fs[i])
            mp[y].push_back(i);
        sum += cnt[i];
    }
    printf("%lld\n",num);
    return 0;
}