#include <cstdio>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
using namespace std;

vector<int> ps;
int sito[10010];
void init()
{
    for(int i = 2; i <= 10000; i++)
    {
        if (sito[i])
            continue;
        ps.push_back(i);
        sito[i] = i;
        for(int w = 2; w*i <= 10000; w++)
            if (!sito[w*i])
                sito[w*i] = i;
    }
}

vector<int> factor(int x)
{
    vector<int> sol;
    int t = 0;
    while(t < ps.size())
    {
        if (x%ps[t]==0)
        {
            while(x%ps[t]==0)
                x/=ps[t];
            sol.push_back(ps[t]);
        }
        t++;
    }
    if ( x > 1)
    {
        sol.push_back(x);
        return sol;
    }
    return sol;
}

bool inters(vector<int>&a,vector<int>&b)
{
    int i = 0, j = 0;
    while(i < a.size() && j < b.size())
    {
        if (a[i] < b[j])
            i++;
        else if (a[i] > b[j])
            j++;
        else
            return true;
    }
    return false;
}
vector<int> fs[30010];
unordered_map<int,vector<int>> mp;
int s[30010];

int a[30010];
int cnt[30010];
int n;

void cmprs()
{
    sort(a,a+n);
    cnt[0] = 1;
    int wq = 0;
    for(int i = 1; i < n; i++)
        if (a[i] == a[i-1])
            cnt[wq]++;
        else
        {
            wq++;
            a[wq] = a[i];
            cnt[wq] = 1;
        }
    n = wq+1;
}

long long stupid(int n)
{
    int sum = 0;
    long long num = 0;
    for(int i = 0; i < n; i++)
    {
        int x = a[i];
        int cntx = 0;
        for(auto y : fs[i])
            for(auto w : mp[y])
            {
                if (s[w] < i)
                    cntx+= cnt[w];
                s[w] = i;
            }
        num += cnt[i]*(sum-cntx);
        for(auto y : fs[i])
            mp[y].push_back(i);
        if (a[i] == 1)
            num += cnt[i]*(cnt[i]-1)/2;
        sum += cnt[i];
    }
    return num;
}
unordered_map<int, int> numf;
long long solve(int n)
{
    if (n < 3000)
        return stupid(n);
    numf.clear();
    for(int i = 0; i < n; i++)
    {
        for(auto y : fs[i])
            numf[y]++;
    }
    int ind = -1;
    for(auto p : numf)
        if (ind == -1 || abs(p.second-n/2) < abs(numf[ind]-n/2))
            ind = p.first;
    int k = 0;
    for(int i = 0; i < n; i++)
    {
        if (a[i]%ind)
        {
            swap(a[i],a[k]);
            swap(cnt[i],cnt[k]);
            k++;
        }
    }
    long long num = solve(k);
    int sum = 0;
    for(int i = 0; i < k; i++)
        sum += cnt[i];
    for(int i = k; i < n; i++)
    {
        int x = a[i];
        int cntx = 0;
        for(auto y : fs[i])
            for(auto w : mp[y])
            {
                //printf("^ %d %d\n",a[i],a[w]);
                if (s[w] < i)
                {
                    cntx+= cnt[w];
                    //printf("# %d %d\n",a[i],a[w]);
                }
                s[w] = i;
            }
        //printf("@ %d %d\n",a[i],cnt[i]*(sum-cntx));
        num += cnt[i]*(sum-cntx);
        if (a[i] == 1)
            num += cnt[i]*(cnt[i]-1)/2;
    }
    for(int i = k; i < n; i++)
        for(auto y : fs[i])
            mp[y].push_back(i);
    return num;
}
int main()
{
    init();
    //printf("%d\n",ps.size())
    scanf("%d",&n);
    for(int i = 0; i < n; i++)
        scanf("%d",&a[i]);
    cmprs();
    for(int i = 0; i < n; i++)
        fs[i] = factor(a[i]);

    printf("%lld\n",solve(n));
    return 0;
}