#include <cstdio>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
using namespace std;

vector<int> ps;
int sito[1000010];
void init()
{
    for(int i = 2; i <= 10000; i++)
    {
        if (sito[i])
            continue;
        ps.push_back(i);
        sito[i] = i;
        for(int w = 2; w*i <= 10000; w++)
            if (!sito[w*i])
                sito[w*i] = i;
    }
}

vector<int> factor(int x)
{
    vector<int> sol;
    int t = 0;
    while(t < ps.size())
    {
        if (x%ps[t]==0)
        {
            while(x%ps[t]==0)
                x/=ps[t];
            sol.push_back(ps[t]);
        }
        t++;
    }
    if ( x > 1)
    {
        sol.push_back(x);
        return sol;
    }
    return sol;
}

vector<int> fs[30010];
unordered_map<int,vector<int>> mp;
int s[30010];

int a[30010];
int cnt[30010];

bool cmp1(int a, int b)
{
    return a > b;
}
int main()
{
    init();
    //printf("%d\n",ps.size());
    int n;
    scanf("%d",&n);
    for(int i = 0; i < n; i++)
        scanf("%d",&a[i]);
    sort(a,a+n,cmp1);
    cnt[0] = 1;
    int wq = 0;
    for(int i = 1; i < n; i++)
        if (a[i] == a[i-1])
            cnt[wq]++;
        else
        {
            wq++;
            a[wq] = a[i];
            cnt[wq] = 1;
        }
    n = wq+1;
    long long num = 0;
    int sum = 0;
    for(int i = 0; i < n; i++)
    {
        int x = a[i];
        fs[i] = factor(x);
        int cntx = 0;
        for(auto y : fs[i])
        {
            if (mp[y].size() == i)
            {
                cntx = sum;
                break;
            }
            for(auto w : mp[y])
            {
                if (s[w] < i)
                    cntx+= cnt[w];
                s[w] = i;
            }
        }
        num += cnt[i]*(sum-cntx);
        for(auto y : fs[i])
            mp[y].push_back(i);
        if (a[i] == 1)
            num += cnt[i]*(cnt[i]-1)/2;
        sum += cnt[i];
    }
    printf("%lld\n",num);
    return 0;
}