#include <cstdio>
#include <vector>
#include <unordered_map>
using namespace std;

struct p
{
    vector<int> da,ne;
    int nzdD, nzdN;
    int c;
};
unordered_map<int,p> m;

char s[10];

bool test(int k)
{
    for(auto& mx : m)
    {
        int brn = 0, brd = 0;
        for(auto x : mx.second.da)
        {
            if (x%k == 0)
                brn++;
            else
                brd++;
        }
        for(auto x : mx.second.ne)
        {
            if (x%k == 0)
                brd++;
            else
                brn++;
        }
        if (brn > 0 && brd > 0)
            return false;
    }
    return true;
}

int nzd(int a, int b)
{
    if(b == 0)
        return a;
    return nzd(b,a%b);
}

int main()
{
    int n;
    scanf("%d",&n);
    for(int i = 1; i <= n; i++)
    {
        int q;
        scanf("%d %s",&q,s);
        if (s[0] == 'd')
            m[q].da.push_back(i);
        else
            m[q].ne.push_back(i);
    }
    if(test(1))
    {
        printf("1\n");
        return 0;
    }
    int mn = -1;
    for(auto &mx : m)
    {
        int id = mx.first;
        p &s = mx.second;
        if (s.da.size() == 0 || s.ne.size() == 0)
            continue;
        s.nzdD = 0;
        for(auto x : s.da)
            s.nzdD = nzd(s.nzdD,x);
        for(auto x : s.ne)
            s.nzdN = nzd(s.nzdN,x);
        s.c = max(s.nzdN,s.nzdD);
        if (mn == -1 || m[mn].c > s.c)
            mn = id;
    }
    for(int i = 2; i <= m[mn].c; i++)
        if (((m[mn].da[0]%i == 0) || (m[mn].ne[0]%i == 0)) && test(i))
        {
            printf("%d\n",i);
            return 0;
        }
    printf("-1\n");
    return 0;
    int sol = -1;
    for(auto& mx : m)
    {
        vector<int>& da = mx.second.da;
        vector<int>& ne = mx.second.ne;
        if (da.size())
            if (test(da[0]))
                if (da[0] < sol  || sol == -1)
                    sol = da[0];
        if (ne.size())
            if (test(ne[0]))
                if (ne[0] < sol  || sol == -1)
                    sol = ne[0];
    }
    printf("%d\n",sol);
    return 0;
}