#include <cstdio>
#include <iostream>
#include <vector>
#include <map>
#include <bitset>
#include <cstring>

using namespace std;

int n, q;
string s;
bool prime[100000];
vector<int> primes;
void sito()
{
    memset(prime, true, sizeof(bool)*100000);
    for (int i = 2; i * i < 100000; i++)
        if (prime[i])
            for (int j = 2; i * j < 100000; j++)
                prime[i*j] = false;
    for (int i = 2; i < 100000; i++)
        if (prime[i])
            primes.push_back(i);
}

int nzd(int a, int b)
{
    if (b == 0) return a;
    return nzd(b, a%b);
}

bitset<100005> res;
bool svisvi = true;
void f(map<int, vector<pair<int, bool>>>::iterator it)
{
    bool svi = false;
    bitset<100005> tacno, netacno;
    bool first = true, svitrue = true;
    int the;
    // recimo da je true
    for (auto x : it->second)
    {
        if (x.second == false)
        {
            svitrue = false;
            if (first)
            {
                the = x.first;
                first = false;
            }
            else the = nzd(the, x.first);
        }
    }
    if (svitrue)
    {
        svi = true;
        for (auto x : it->second)
        {
            tacno[x.first] = true;
            int tr = x.first;
            for (int i = 0; primes[i] * primes[i] <= tr && tr != 1; i++)
            {
                if (tr % primes[i] == 0)
                {
                    tacno[primes[i]] = true;
                    tr/=primes[i];
                }
            }
        }
        tacno = ~tacno;
    }
    else
    {
        tacno[the] = true;
        int tr = the;
        for (int i = 0; primes[i] * primes[i] <= tr && tr != 1; i++)
        {
            if (tr % primes[i] == 0)
            {
                tacno[primes[i]] = true;
                tr/=primes[i];
            }
        }
    }

    first = true;
    bool svifalse = true;
    // recimo da je false
    for (auto x : it->second)
    {
        if (x.second == true)
        {
            svifalse = false;
            if (first)
            {
                the = x.first;
                first = false;
            }
            else the = nzd(the, x.first);
        }
    }
    if (svifalse)
    {
        svi = true;
        for (auto x : it->second)
        {
            netacno[x.first] = true;
            int tr = x.first;
            for (int i = 0; primes[i] * primes[i] <= tr && tr != 1; i++)
            {
                if (tr % primes[i] == 0)
                {
                    netacno[primes[i]] = true;
                    tr/=primes[i];
                }
            }
        }
        netacno = ~netacno;
    }
    else
    {
        netacno[the] = true;
        int tr = the;
        for (int i = 0; primes[i] * primes[i] <= tr && tr != 1; i++)
        {
            if (tr % primes[i] == 0)
            {
                netacno[primes[i]] = true;
                tr/=primes[i];
            }
        }
    }

    cout << it->first << endl;

    cout << "TACNO: ";
    for (int i = 1; i <= n; i++)
        cout << (tacno[i] ? 1 : 0) << " ";
    cout << endl << "NETACNO: ";
    for (int i = 1; i <= n; i++)
        cout << (netacno[i] ? 1 : 0) << " ";

    cout << endl << "--------------" << endl;

    res = res&(tacno|netacno);
    if (!svi) svisvi = false;
}

map<int, vector<pair<int, bool>>> m;
int main()
{
    /*bitset<100005> b, c;
    b[5] = true; b[7] = true;
    c[2] = true;
    b = b|c;
    for (int i = 0; i < 10; i++) printf("%d %d\n", i, b[i] ? 1 : 0);*/

    sito();
    res = ~res;

    scanf("%d", &n);
    for (int i = 1; i <= n; i++)
    {
        scanf("%d", &q);
        cin >> s;
        if (s[0] == 'd') m[q].push_back(make_pair(i, true));
        else m[q].push_back(make_pair(i, false));
    }

    for (auto it = m.begin(); it != m.end(); it++) f(it);

    int sol = 1e9;
    bool ne = false;
    for (int i = 2; i <= n; i++)
        if (res[i])
            sol = min(sol, i);
        else
            ne = true;
        //printf("%d %d\n", i, res[i] ? 1 : 0);
    printf("%d", svisvi || sol == 1e9 || !ne ? -1 : sol);

    return 0;
}

/*

5
1 da
2 ne
1 ne
3 da
2 ne

10
1 da
2 da
3 da
4 da
5 da
6 da
7 da
8 da
9 da
10 da

20
1 da
1 ne
1 da
1 ne
1 da
1 ne
1 da
1 ne
1 da
1 ne
1 da
1 ne

8
1 da
2 ne
1 da
2 ne
1 da
2 ne
1 da
2 ne

*/