#include <cstdio>
#include <map>
#include <vector>
#include <algorithm>

using namespace std;

map<int, vector<int> > mDa;
map<int, vector<int> > mNe;

map<int, int> mRaz;

int main()
{
    int n;
    scanf("%d", &n);
    int q;
    char c1, c2;

    for(int i = 1; i < n; i++) {
        scanf("%d %c%c\n", &q, &c1, &c2);
        if(c1 == 'd') {
            mDa[q].push_back(i);
        } else {
            mNe[q].push_back(i);
        }
    }

    scanf("%d %c%c", &q, &c1, &c2);
    if(c1 == 'd') {
        mDa[q].push_back(n);
    } else {
        mNe[q].push_back(n);
    }

    int raz;
    for(auto it = mDa.begin(); it != mDa.end(); it++) {
        raz = -1;
        for(int i = 1; i < it->second.size(); i++) {
            if(raz == -1)
                raz = it->second[i] - it->second[i - 1];
            else if(it->second[i] - it->second[i - 1] != raz) {
                raz = -1;
                break;
            }
        }
        mRaz[it->first] = raz;
    }

    int sol = 1e9;
    for(auto it = mNe.begin(); it != mNe.end(); it++) {
        raz = -1;
        for(int i = 1; i < it->second.size(); i++) {
            if(raz == -1)
                raz = it->second[i] - it->second[i - 1];
            else if(it->second[i] - it->second[i - 1] != raz) {
                raz = -1;
                break;
            }
        }
        mRaz[it->first] = max(mRaz[it->first], raz);
        if(mRaz[it->first] != -1)
            sol = min(mRaz[it->first], sol);
    }

    if(sol == 1)
        sol = -1;
    printf("%d", sol);
    return 0;
}
/*
5
1 da
2 ne
1 ne
3 da
2 ne

3
1 da
1 ne
1 ne
*/