#include <cstdio>
#include <algorithm>
#include <vector>

#define times(i,N) for (int i = 0; i < (N); i++)
#define timesr(i,N) for (int i = N-1; i >= 0; i--)

#define printfaj(Bh) \
    times(i,N) {\
        times(j,M) printf("%d ", Bh[i][j]);\
        printf("\n");\
    }

const int INF = 0x7fffffff;

using namespace std;

int Bh[2000][2000], Bv[2000][2000], Dh[2000][2000], Dv[2000][2000];

int main()
{
    int N,M,Dl,Bl;scanf("%d%d%d%d",&N,&M,&Dl,&Bl);

    int ukupno = 0;

    times(i,N) times(j,M) {
        int c;
        while ((c = getchar()) < '0') ;
        if (c == '1') {
            Bv[i][j] = 0;
            Bh[i][j] = 0;
            Dv[i][j] = 0;
            Dh[i][j] = 0;
        } else {
            Bh[i][j] = min(Bl, j==0 ? 1 : (Bh[i][j-1] + 1));
            Bv[i][j] = min(Bl, i==0 ? 1 : (Bv[i-1][j] + 1));
            Dh[i][j] = min(Dl, j==0 ? 1 : (Dh[i][j-1] + 1));
            Dv[i][j] = min(Dl, i==0 ? 1 : (Dv[i-1][j] + 1));
            if (Bh[i][j] >= Bl) ukupno++;
            if (Bv[i][j] >= Bl) ukupno++;
        }
    }

    times(i,N) {
        int Bp = 0;
        timesr(j, M) {
            if (Bh[i][j] == 0) Bp = 0;
            else {
                Bp = min(Bp + 1, Bl);
                Bh[i][j] = max(0, Bh[i][j] + Bp - Bl);
            }
        }
    }

    times (j,M) {
        int Bp = 0;
        timesr(i, N) {
            if (Bv[i][j] == 0) Bp = 0;
            else {
                Bp = min(Bp + 1, Bl);
                Bv[i][j] = max(0, Bv[i][j] + Bp - Bl);
            }
        }
    }
    times(i, N) {
        int dod = Dl-1;
        int zb = 0;
        int mm = Bh[i][0];
        int mc = 1;
        times(j, Dl) {
            zb += Bv[i][j];
            if (Bh[i][j] > mm) {mm = Bh[i][j]; mc = 1;}
            else if (Bh[i][j] == mm) mc++;
        }
        times(j,Dl-1) Dh[i][j] = 0;
        int od = 0;
        while (1) {
            if (Dh[i][dod] == Dl)   Dh[i][dod] = zb + mm + (mm == Bl ? mc - 1 : 0);
            else                    Dh[i][dod] = 0;
            dod++;
            if (dod >= M) break;
            zb += Bv[i][dod] - Bv[i][od];
            if (Bh[i][dod] > mm) {mm = Bh[i][dod]; mc = 1;}
            else if (Bh[i][dod] == mm) mc++;
            if (mm == Bh[i][od]) {
                mm = Bh[i][od+1];
                for (int j = od + 1; j <= dod; j++)
                    if (Bh[i][j] > mm) {mm = Bh[i][j]; mc = 1;}
                    else if (Bh[i][j] == mm) mc++;
            }
            od++;
        }
    }

    times(j, M) {
        int dod = Dl - 1;
        int zb = 0;
        int mm = Bv[0][j];
        int mc = 1;
        times(i, Dl) {
            zb += Bh[i][j];
            if (Bv[i][j] > mm) {mm = Bv[i][j]; mc = 1;}
            else if (Bv[i][j] == mm) mc++;
        }
        times(i, Dl-1) Dv[i][j] = 0;
        int od = 0;
        while (1) {
            if (Dv[dod][j] == Dl)   Dv[dod][j] = zb + mm + (mm == Bl ? mc - 1 : 0);
            else                    Dv[dod][j] = 0;
            dod++;
            if (dod >= N) break;
            zb += Bh[dod][j] - Bh[od][j];
            if (Bv[dod][j] > mm) {mm = Bv[dod][j]; mc = 1;}
            else if (Bv[dod][j] == mm) mc++;
            if (mm == Bv[od][j]) {
                mm = Bv[od+1][j];
                mc = 1;
                for (int i = od + 1; i <= dod; i++)
                    if (Bv[i][j] > mm) {mm = Bv[i][j]; mc = 1;}
                    else if (Bv[i][j] == mm) mc++;
            }
            od++;
        }
    }

    int mm = -1;
    times(i,N)times(j,M) {
        mm = max(mm, max(Dv[i][j],Dh[i][j]));
    }

    printf("%d\n", ukupno - mm);
}
/*
5 6 3 3
110111
000001
000001
111101
100010

1 10 5 3
0001000000
*/