#include <iostream>
#include <map>
#include <vector>
#include <cmath>

using namespace std;

int main()
{
    cin.sync_with_stdio(false);
    cin.tie(NULL);

    vector< int > div;
    div.push_back(1);

    int n, k, j, l, r;
    cin >> n >> k;
    vector< int > s(n);

    for (int i = 2; i <= sqrt(n); i++) {
        if (n % i == 0) {
            div.push_back(i);
            div.push_back(n/i);
        }
    }

    div.push_back(n);
    vector< bool > divb (div.size(), true);

    map< int, vector< int > > m;

    for (int i = 0; i < n; i++) {
        cin >> s[i];
        m[s[i]].push_back(i);

        if (m[s[i]].size() > k) {
            //cout << "group " << s[i] << endl;

            vector< int > &v = m[s[i]];
            int bg = v[v.size() - k - 1], en = v[v.size() - 1];
            int range = en - bg + 1;

            //cout << bg << " " << en << " " << range << endl;
            j = 0;

            for (; j < div.size(); j++) {
                if (divb[j]) {
                    l = bg - bg % div[j];
                    if (l + div[j] > en) {
                        for (r = j; r < div.size(); r++) {
                            if (div[r] % div[j] == 0) {
                                divb[r] = false;
                            }
                        }
                    }
                }
            }
        }
    }

    int sol = 0;

    for (int i = 0; i < div.size(); i++) {
        if (divb[i]) {
            //cout << div[i] << " ";
            sol++;
        }
    }
    //cout << endl;
    cout << sol;
}