#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long s;

void choose (vector< int > &v, int c, int i, long long p) {
    if (c == 1) {
        for (; i < v.size(); i++) {
            s += (p * v[i]) % 1000000007;
            s %= 1000000007;
        }
    }
    else {
        for (; i < v.size() - c + 1; i++) {
            choose(v, c-1, i+1, (p*v[i]) % 1000000007);
        }
    }
}

void choose2 (vector< vector< long long > > &v, int c, long long p, int bi, vector< long long > &b) {
    if (c == v.size() - 1) {
        for (int i = 0; i < v[c].size(); i++) {
            if (v[c][i] != 0) {
                s += ((p * v[c][i]) % 1000000007) * b[bi+i] % 1000000007;
                s %= 1000000007;
                //cout << s << " " << p << " " << v[c][i] << " " << b[bi+i+1] << endl;
            }
        }
    }
    else {
        for (int i = 0; i < v[c].size(); i++) {
            if (v[c][i] != 0) {
                choose2(v, c+1, (p * v[c][i]) % 1000000007, bi+i+1, b);
            }
        }
    }
}

int main()
{
    int i, j, q;
    long long n, m;
    cin >> n >> m;
    vector< vector< int > > k (n, vector< int > (m));

    for (i = 0; i < n; i++) {
        for (j = 0; j < m; j++) {
            cin >> k[i][j];
        }
    }

    vector< vector< bool > > t (n, vector< bool > (m));
    vector< vector< long long > > x (n, vector< long long > (m, 0));

    for (i = 0; i < n; i++) {
        for (j = 0; j < m; j++) {
            cin >> q;
            t[i][j] = (q == 1);
            if (t[i][j]) {
                s = 0;
                choose (k[i], j+1, 0, 1ll);
                x[i][j] = s;
            }
        }
    }

    vector< long long > b (n * m);

    for (i = 0; i < n*m; i++) {
        cin >> b[i];
    }

    s = 0;
    choose2 (x, 0, 1, 0, b);

    cout << s;
}