#include <iostream>
#include <stdio.h>
#include <math.h>
#include <vector>

using namespace std;

bool isPrime(int x)
{
    int k = sqrt(x)+1;
    int i=2;
    while(i<k)
    {
        if(x%i == 0) return false;
        i++;
    }
    return true;
}

int main()
{
    int n;
    scanf("%i",&n);

    int cards[n];
    for(int i=0;i<n;i++)
    {
        scanf("%i",&cards[i]);
    }

    int wins = 0;
    int total = (n*(n-1))/2;
    vector<int> complex;
    vector<int> prime;
    //int lonelyPrimes = 0;
    for(int i=0;i<n;i++)
    {
        if(isPrime(cards[i]))
        {
            bool found = false;
            for(int j=0;j<n;j++)
            {
                if(i!=j && cards[j] == cards[i]) found = true;
            }
            if(!found && cards[i]!=1) prime.push_back(cards[i]);
        }
        else
        {
            complex.push_back(cards[i]);
        }
    }
    for(int i=0;i<complex.size();i++)
    {
        for(int j=i+1;j<complex.size();j++)
        {
            bool found = false;
            int minS;
            int minX;
            int bigX;
            if(complex[i]<complex[j])
            {
                minS = sqrt(complex[i])+1;
                minX = i;
                bigX = j;
            }
            else
            {
                minS = sqrt(complex[j])+1;
                minX = j;
                bigX = i;
            }
            int x=2;
            while(!found && x<=minS)
            {
                if(complex[minX]%x==0)
                {
                    if(complex[bigX]%x==0 || (complex[bigX]%(complex[minX]/x)==0 && complex[minX]/x != 1))
                    {
                        found = true;
                        /*printf("%i %i %i",cards[bigX],cards[minX],x);
                        printf("\n");*/
                    }
                }
                x++;
            }
            if(found || complex[bigX]%complex[minX] == 0) wins+=1;
        }
    }

    for(int i=0;i<complex.size();i++)
    {
        for(int j=0;j<prime.size();j++)
        {
            if(complex[i]%prime[j]==0) {wins+=1; printf("%i %i \n",complex[i],prime[j]);}
        }
    }

    int ans = total-wins;
    /*for(int i=1;i<=lonelyPrimes;i++)
    {
        wins+=(n-i);
    }*/

    /*printf("%i",lonelyPrimes);
    for(int i=0;i<complex.size();i++)
    {
        printf("%i ",complex[i]);
    }*/
    printf("%i",ans);
    return 0;
}