#include <bits/stdc++.h>
using namespace std;

#define F(i, n) for(int (i) = 1; (i) <= (n); i++)
#define fast_scan ios_base::sync_with_stdio(false)
#define fi first
#define se second
#define mp make_pair
#define p push
#define pb push_back
#define pf push_front
#define pp pop
#define ppb pop_back
#define ppf pop_front
#define t top
#define e emtpy
#define f front
#define b back
#define DEBUG cout<<"DEBUG"<<endl

typedef long long ll;
typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef queue<int> qi;
typedef queue<ii> qii;

const int N = 10010;

struct odgovor{
    int q;
    int pos;
    int ans;

    friend bool operator < (const odgovor& a, const odgovor& b){
        if (a.q < b.q)
            return true;
        else if (a.q > b.q)
            return false;
        else{
            return (a.pos < b.pos);
        }
    }

    void print(){
        cout<<q<<" "<<pos<<" "<<ans<<endl;
    }
};

int n;
odgovor odg[N];
string s;
int pr[N];
int sol;

bool prime(int x){
    if (x <= 3)
        return true;
    else{
        if (x  % 2 == 0 || x % 3 == 0)
            return false;

        for (int i = 5; i*i<=x; i+=6)
            if(x % i == 0 || x % (i + 2) == 0)
                return false;

        return true;
    }
}

void forbid(int x, int y){
    bool prx = prime(x);
    bool pry = prime(y);

    if (prx && pry){
        pr[1] = pr[x] = pr[y] = -1;
    }
    else if (prx && !pry){
        if (y % x != 0){
            pr[x] = pr[1] = -1;
            pr[y] = -1;
            for (int j = y/2; j >= 1; j--){
                if (y % j == 0)
                    pr[j] = -1;
            }
        }
        else{
            y /= x;
            for (int j = y/2; j >= 1; j--){
                if (y % j == 0)
                    pr[j] = -1;
            }
        }
    }
    else if (!prx && pry){
        if (x % y != 0){
            pr[x] = pr[1] = -1;
            pr[y] = -1;
            for (int j = x/2; j >= 1; j--){
                if (x % j == 0)
                    pr[j] = -1;
            }
        }
        else{
            x /= y;
            for (int j = x/2; j >= 1; j--){
                if (x % j == 0)
                    pr[j] = -1;
            }
        }
    }
    else{
        int mx = max(x, y)/2;
        for (int i = 1; i <= mx; i++){
            if (x % i == 0 && y % i != 0)
                pr[i] = -1;
            else if(x % i != 0 && y % i == 0)
                pr[i] = -1;
        }
    }
}

int main(){
    //freopen("test.txt", "r", stdin);
    fast_scan;

    cin>>n;
    F(i, n){
        cin>>odg[i].q;
        cin>>s;
        if (s == "da")
            odg[i].ans = 1;
        else
            odg[i].ans = 0;
        odg[i].pos = i;
    }

    sort(odg + 1, odg + 1 + n);

    for (int i = 1; i <= n; i++){
        int upp = i;
        while(upp <= n && odg[upp].q == odg[i].q)
            upp++;
        upp--;
        for (int ii = i; ii < upp; ii++){
            for (int j = ii + 1; j <= upp; j++){
                if (odg[ii].ans == odg[j].ans){
                    forbid(odg[ii].pos, odg[j].pos);
                }
            }
        }
        i = upp;
    }

    sol = -1;
    F(i, n)
        if (pr[i] != -1){
            sol = i;
            break;
        }

    cout<<sol<<endl;
    return 0;
}