#include <cstdio>
#include <algorithm>

// HARI

using namespace std;

long long A[200000];
long long N, K;

void makeAllZero(long long a[], long long e)
{
    for(long long i=0; i<e; i++)
    {
        a[i]=0;
    }
}

bool isMoreThenTwo(long long start, long long e)
{
    long long a_local[e];
    long long i_a_local = 0;

    makeAllZero(a_local, e);

     for(long long i=start; i<start+e; i++)
    {
        if(count(a_local, a_local+e, A[i]) == 0)
        {
            a_local[i_a_local] = A[i];
            i_a_local++;

            if(count(A+start, A+start+e, A[i]) > K)
            {
                return true;
            }
        }
    }

    return false;
}

bool isBox(long long e) // e je br elemenata u kutiji
{

    for(long long i=0; i<N/e; i++)
    {
        if(isMoreThenTwo(i*e, e))
        {
            return false;
        }
    }

    return true;
}

int main()
{
    long long rezultat = 1;

    scanf("%d %d", &N, &K);

    for(long long i = 0; i<N; i++)
    {
        scanf("%d", &A[i]);
    }

    for(long long i = N/2; i>1 ; i--)
    {
        if(N%i==0)
        {
            if(isBox(i) == true)
            {
                rezultat++;
            }
        }
    }

    printf("%d", rezultat);

    return 0;
}