#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>

using namespace std;

int occurances (int *arr, int from, int to, int num)
{
    int value = 0;
    for (int i = from; i < to; i++)
        if (arr[i] == num) value++;
    return value;
}

int main()
{
    ios::sync_with_stdio(false);

    int n, k, fails = 0;
    cin >> n >> k;
    int stick[n];

    for (int i = 0; i < n; i++)
    {
        cin >> stick[i];
    }
    int root = floor(sqrt(n));
    vector<int> divs;
    for (int i = 1; i <= root; i++)
    {
        double division = (double)n / (double)i;
        if (division == n / i)
        {
            if (n / i == i)
                divs.push_back(i);
            else
            {
                divs.push_back(division);
                divs.push_back(i);
            }
        }
    }
    for (size_t i = 0; i < divs.size(); i++)
    {
        int div = divs[i];
        bool good = true;
        for (int j = 0; j < n / div; j++)
        {
            int a = j*div;
            int b = (j+1)*div;
            for (int s = a; s < b; s++)
                if (occurances(stick, a, b, stick[s]) > k)
                {
                    good = false;
                    fails++;
                    break;
                }
            if (good == false) break;
        }
    }
    cout << divs.size() - fails;

    return 0;
}