#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

void factors(int n, vector<int> &f1)
{
    for(int i=2;i<=n/2;i++)
        if(n%i==0)
        {
            f1.push_back(i);
            f1.push_back(n/i);
        }
    if(f1.size()==0)
        f1.push_back(n);
}

create_f(vector<int> &v, vector<vector<int> >&f)
{
    for(int i=0;i<v.size();i++)
        factors(v.at(i),f.at(i));
}

bool check(vector<int> f1, vector<int> f2)
{
    int a=0,b=0;
    while(a<f1.size() && b<f2.size())
    {
        if(f1.at(a)==f2.at(b))
            return false;
        else if(f1.at(a)>f2.at(b))
            b++;
        else
            a++;
    }
    return true;
}

int main()
{
    int n;
    cin>>n;
    vector<int> v;
    int k=0;
    int c,m=n;
    for(int i=0;i<m;i++)
    {
        cin>>c;
        if(c==1)
        {
            k++;
            n--;
        }
        else
            v.push_back(c);
    }
    vector<int> f1;
    vector<vector<int> >f(n,f1);
    create_f(v,f);
    //for(int i=0;i<n;i++){for(int j=0;j<f.at(i).size();j++)cout<<f.at(i).at(j)<<" ";cout<<endl;}
    int sol=0;
    for(int i=0;i<n;i++)
        for(int j=i+1;j<n;j++)
            if(check(f.at(i),f.at(j)))
                sol++;
    sol+=k*(n+k-1);
    cout<<sol;
    return 0;
}