#include <stdio.h>

typedef unsigned char u8;
typedef unsigned long u32;

const unsigned MAX_BACANJA = 1000000;
u8 bacanja[2*MAX_BACANJA];

struct Bacanje {
    u32 brojac;
};

Bacanje sb1[6];
Bacanje sb2[6];

int main()
{
    unsigned br_bac;
    scanf("%u", &br_bac);
    for(int i = 0; i < 2 * br_bac; ++i)
        scanf("%u", bacanja + i);

    int max_r1 = 0;
    for (int k = 1; k <= br_bac; ++k) {

        for(int i = 0; i < 6; i++) {
            sb1[i].brojac = 0;
            sb2[i].brojac = 0;
        }

        for(int i = 0 ; i < k; ++i) {
            ++sb1[bacanja[i] - 1].brojac;
            ++sb2[bacanja[i + k] - 1].brojac;
        }

        u32 r1 = 0;
        for(int vr1 = 2; vr1 <= 6; vr1++) {
            u32 kom = sb1[vr1 - 1].brojac;
            u32 sub = 0;
            for(int vr2 = 1; vr2 < vr1 && sub < kom; vr2++) {
                sub += sb2[vr2 - 1].brojac;
                if (sub > kom) {
                    sub = kom;
                }
                sb2[vr2 - 1].brojac -= sub;
            }
            r1 += sub;
        }

        if (r1 > max_r1) {
            max_r1 = r1;
        }
    }

    printf("%d", max_r1);

    return 0;
}