#include <iostream>
#include <string>
#include <vector>

#include <algorithm>
using namespace std;

struct odgovor
{
    int br;
    int odg;
    int index;
};

bool poredi(odgovor prvi, odgovor drugi)
{
    return (prvi.br<drugi.br);
}

bool poredib(odgovor prvi, odgovor drugi)
{
    return (prvi.br<drugi.br);
}

int main()
{
    int n;
    string str;

    cin >>n;
    vector<odgovor> niz(n),sortniz(n);

    for (int i=0; i<n; i++)
    {
        cin >>niz[i].br;
        cin >>str;

        if (str=="da") niz[i].odg=1;
        else niz[i].odg=0;

        niz[i].index=i;

        sortniz[i].br=niz[i].br;
        sortniz[i].odg=niz[i].odg;
        sortniz[i].index=niz[i].index;
    }

    sort(sortniz.begin(),sortniz.end(), poredi);
    vector<odgovor> birani(n);
    int br=0;

    birani[br]=sortniz[0]; br++;
    for (int i=0; i<n-1; i++)
    {
        if (sortniz[i].br!=sortniz[i+1].br)
        {
            birani[br]=sortniz[i+1];

            br++;
        }
    }

    bool bul;
    int index,k;


    for (int i=0; i<n+1; i++)
    {
        bul=true;
        for (int j=0; j<br; j++)
        {
            birani[j].odg=-1;
        }

        for (int j=0; j<n; j++)
        {
            index=lower_bound(birani.begin(), birani.begin()+br,niz[j], poredib)-birani.begin();
            //cout <<index <<endl;

            if (birani[index].odg==-1)
            {
                if ((j+1)%(i+1)==0) birani[index].odg=(niz[j].odg+1)%2;
                else birani[index].odg=niz[j].odg;
            }
            else
            {
                if ((j+1)%(i+1)==0)
                {
                    if (birani[index].odg==niz[j].odg)
                    {
                        bul=false;
                        break;
                    }
                }

                else
                {
                    if (birani[index].odg!=niz[j].odg)
                    {
                        bul=false;
                        break;
                    }
                }
            }
        }

        if (bul)
        {
            k=i+1;
            break;
        }

    }

    if (bul) cout <<k;
    else cout <<-1;


    return 0;
}