#include <bits/stdc++.h>
using namespace std;

const int N=1e5+10;

int n, sol=N;
int v[N][2]; //0 for 0, 1 for 1
vector<pair<int, int> > init;
int mark[N];

void fail ()
{
    cout << "-1";
    exit(0);
}

void solve (int t)
{
    if (t==1) return;

    for (int i=1;i<=n;i++) mark[i]=-1;
    for (int i=t;i<=n;i+=t)
    {
        if (mark[i]==-1) mark[init[i].first]=1-init[i].second;
        else if (mark[init[i].first]!=1-init[i].second) return;
    }

    for (int i=1;i<=n;i++)
    {
        if (i%t==0) continue;
        if (mark[i]==-1) mark[i]=init[i].second;
        else if (mark[i]!=init[i].second) return;
    }

    sol=min(sol, t);
}

void try_for (int x)
{
    int rt=sqrt(x);
    for (int i=1;i<=rt;i++)
    {
        if (x%i==0)
        {
            solve(i);
            solve(x/i);
        }
    }
}

int main()
{
    scanf ("%d", &n);
    for (int i=1;i<=n;i++)
    {
        int x;
        char type[5];
        scanf ("%d%s", &x, type);

        if (type[0]=='n')
        {
            if (v[x][0]==0) v[x][0]=i;
            init.push_back({i, 0});
        }
        else
        {
            if (v[x][1]==0) v[x][1]=i;
            init.push_back({i, 1});
        }
    }

    for (int i=1;i<=n;i++)
    {
        if (v[i][0]!=0 && v[i][1]!=0)
        {
            //cerr << i << " " << v[i][0] << " " << v[i][1] << endl;
            try_for (v[i][0]);
            try_for (v[i][1]);
            break;
        }
    }

    if (sol==N) fail();
    else cout << sol;

    return 0;
}