#include <cstdio>
using namespace std;
#define maxN 2000

int n, m, a, b;
int hor[maxN][maxN];
int ver[maxN][maxN];
char mat[maxN + 1][maxN + 1];
int d[maxN][maxN][4];
int sum;
int mx;

int f(int x) {
  if (x > b)
    return b;
  return x;
}

int calc(int x, int y, int z) {
  //izracunava broj kombinacija da se stavi brod ako gore ima x - 1, a dole y - 1, i ima z izmedju
  //poziva se sa (d[i][j][0], d[i][j][2], 1) ili (d[i][j][1], d[i][j][3], 1)
  //ima matricu mem za to
  if (x + y + z - 1 >= b)
     return x + y + z - 1 - b;
  return 0;
}

void setup() {
  for (int i = 0; i < n; i++)
    d[i][0][1] = mat[i][0] == '0' ? 1 : 0;
  for (int j = 1; j < m; j++)
    for (int i = 0; i < n; i++)
      d[i][j][1] = mat[i][j] == '0' ? d[i][j-1][1] + 1 : 0;

  for (int i = 0; i < n; i++)
    d[i][m-1][3] = mat[i][m-1] == '0' ? 1 : 0;
  for (int j = m - 2; j >= 0; j--)
    for (int i = 0; i < n; i++)
      d[i][j][3] = mat[i][j] == '0' ? d[i][j+1][3] + 1 : 0;

  for (int j = 0; j < m; j++)
    d[0][j][2] = mat[0][j] == '0' ? 1 : 0;
  for (int i = 1; i < n; i++)
    for (int j =  0; j < m; j++)
      d[i][j][2] = mat[i][j] == '0' ? d[i-1][j][2] + 1 : 0;
    
  for (int j = 0; j < m; j++)
    d[n-1][j][0] = mat[n-1][j] == '0' ? 1 : 0;
  for (int i = n - 2; i >= 0; i--)
    for (int j = 0; j < m; j++)
      d[i][j][0] = mat[i][j] == '0' ? d[i+1][j][0] + 1 : 0;
  for (int k = 0; k < 4; k++)
    for (int i = 0; i < n; i++)
      for (int j = 0; j < m; j++)
        d[i][j][k] = f(d[i][j][k]);
  for (int i = 0; i < n; i++)
    for (int j = 0; j < m; j++) {
      hor[i][j] = mat[i][j] == '0' ? calc(d[i][j][1], d[i][j][3], 1) : 0;
      ver[i][j] = mat[i][j] == '0' ? calc(d[i][j][0], d[i][j][2], 1) : 0;
    }
}

void test() {
  for (int k = 0; k < 4; k++) {
    printf("test %d\n\n", k);
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < m; j++)
        printf("%d ", d[i][j][k]);
      printf("\n");
    }
  }
}

void tset() {
  printf("HOR\n\n");
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++)
      printf("%d ", hor[i][j]);
    printf("\n");
  }
  printf("VER\n\n");
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++)
      printf("%d ", ver[i][j]);
    printf("\n");
  }
}

int main() {
  scanf("%d %d %d %d", &n, &m, &a, &b);
  for (int i = 0; i < n; i++)
    scanf("%s", mat[i]);
  setup();
  //test();
  //tset();
  mx = 0;
  if (a <= n) {
    for (int j = 0; j < m; j++) {
      int s = 0;
      int l = 0;
      for (int i = 0; i < n; i++) {
        s += hor[i][j];
        if (mat[i][j] == '0')
          l++;
        else
          l = 0;
        if (i >= a)
          s -= hor[i - a][j];
        if (l >= a) {
          int tmp = s + calc(d[i-a+1][j][2], d[i][j][0], a);
          if (tmp > mx)
            mx = tmp;
          //printf("test: vertikalno(%d, %d) = %d + %d\n", i + 1, j + 1, s, tmp);
        }
      }
    }
  }
  if (a <= m) {
    for (int i = 0; i < n; i++) {
      int s = 0;
      int l = 0;
      for (int j = 0; j < m; j++) {
        s += ver[i][j];
        if (mat[i][j] == '0')
          l++;
        else
          l = 0;
        if (i >= a)
          s -= ver[i][j-a];
        if (l >= a) {
          int tmp = s + calc(d[i][j-a+1][1], d[i][j][3], a);
          if (tmp > mx)
            mx = tmp;
          //printf("test: horizontalno(%d, %d) = %d\n", i + 1, j + 1, tmp);
        }
      }
    }
  }
  sum = 0;
  for (int i = 0; i < n; i++)
    for (int j = 0; j < m; j++) {
      if (d[i][j][0] >= b)
        sum++;
      if (d[i][j][1] >= b)
        sum++;
    }
  //printf("sum = %d\n", sum);
  printf("%d\n", sum - mx);
  //scanf("%d", &n);
  return 0;
}