#include <cstdio>
#include <vector>
using namespace std;

vector<int> ps;
int sito[1000010];
void init()
{
    for(int i = 2; i <= 1000000; i++)
    {
        if (sito[i])
            continue;
        if (i <= 100)
            ps.push_back(i);
        sito[i] = i;
        for(int w = 2; w*i <= 1000000; w++)
            if (!sito[w*i])
                sito[w*i] = i;
    }
}

vector<int> factor(int x)
{
    vector<int> sol;
    int t = 0;
    while(x > 1000000 && t < ps.size())
    {
        if (x%ps[t]==0)
        {
            while(x%ps[t]==0)
                x/=ps[t];
            sol.push_back(ps[t]);
        }
        t++;
    }
    while(x > 1)
    {
        int p = sito[x];
        while(x % p == 0)
            x/=p;
        sol.push_back(p);
    }
    return sol;
}

bool inters(vector<int>&a,vector<int>&b)
{
    int i = 0, j = 0;
    while(i < a.size() && j < b.size())
    {
        if (a[i] < b[j])
            i++;
        else if (a[i] > b[j])
            j++;
        else
        {
            //printf("--%d %d\n",a[i],b[j]);
            return true;
        }
    }
    return false;
}
vector<int> fs[30010];
int main()
{
    init();
    int n;
    scanf("%d",&n);
    long long num = 0;
    for(int i = 0; i < n; i++)
    {
        int x;
        scanf("%d",&x);
        fs[i] = factor(x);
        //printf("$ ");
        //for(auto y : fs[i])
        //    printf("%d ",y);
        //printf("\n");
        for(int j = 0; j < i; j++)
            if (!inters(fs[i],fs[j]))
                num++;
    }
    printf("%lld\n",num);
    return 0;
}