#include <cstdio>
#include <vector>
#include <unordered_map>
using namespace std;

struct p
{
    vector<int> da,ne;
};
unordered_map<int,p> m;

char s[10];

bool test(int k)
{
    for(auto& mx : m)
    {
        int brn = 0, brd = 0;
        for(auto x : mx.second.da)
        {
            if (x%k == 0)
                brn++;
            else
                brd++;
        }
        for(auto x : mx.second.ne)
        {
            if (x%k == 0)
                brd++;
            else
                brn++;
        }
        if (brn > 0 && brd > 0)
            return false;
    }
    return true;
}
int main()
{
    int n;
    scanf("%d",&n);
    for(int i = 1; i <= n; i++)
    {
        int q;
        scanf("%d %s",&q,s);
        if (s[0] == 'd')
            m[q].da.push_back(i);
        else
            m[q].ne.push_back(i);
    }
    int sol = -1;
    for(auto& mx : m)
    {
        vector<int>& da = mx.second.da;
        vector<int>& ne = mx.second.ne;
        if (da.size())
            if (test(da[0]))
                if (da[0] < sol  || sol == -1)
                    sol = da[0];
        if (ne.size())
            if (test(ne[0]))
                if (ne[0] < sol  || sol == -1)
                    sol = ne[0];
    }
    printf("%d\n",sol);
    return 0;
}