#include <cstdio>
#include <algorithm>
#include <unordered_map>

#define AA 1000000000

using namespace std;

unordered_map<long long, int> lcd;
int nzd(int a, int b)
{
    if (lcd[a*AA+b] != 0) return lcd[a*AA+b];
    if (b == 0) return lcd[a*AA+b] = a;
    return lcd[a*AA+b] = nzd(b, a%b);
}

int a[30005];
int main()
{
    int n, sol = 0;
    scanf("%d", &n);
    for (int i = 0; i < n; i++) scanf("%d", &a[i]);
    sort(a, a+n);

    for (int i = 0; i < n-1; i++)
        for (int j = i+1; j < n; j++)
            if (nzd(max(a[i], a[j]), min(a[i], a[j])) == 1) sol++;

    printf("%d", sol);

    return 0;
}