#include <iostream>
#include <map>
#include <vector>
#include <cstdio>

using namespace std;

map<int, vector<pair<int, bool>>> m;
int n, q;
string s;

bool f(int k)
{
    for (auto it = m.begin(); it != m.end(); it++)
    {
        bool firstyes = true, firstno = true, yes, no;
        for (auto x : it->second)
        {
            if (x.first % k == 0)
            {
                if (firstyes) yes = x.second, firstyes = false;
                else if (yes != x.second) return false;
            }
            else
            {
                if (firstno) no = x.second, firstno = false;
                else if (no != x.second) return false;
            }
        }
    }
    return true;
}

int main()
{
    scanf("%d", &n);
    for (int i = 1; i <= n; i++)
    {
        scanf("%d", &q);
        cin >> s;
        if (s[0] == 'd') m[q].push_back(make_pair(i, true));
        else m[q].push_back(make_pair(i, false));
    }

    for (int i = 2; i <= n; i++)
    {
        if (f(i))
        {
            cout << i;
            return 0;
        }
    }
    cout << -1;

    return 0;
}