#include <cstdio>
#include <queue>
#include <algorithm>

using namespace std;

char s[2010];
bool mat[2010][2010];
int resV[2010][2010];
int resH[2010][2010];

struct polje {
    int i;
    int j;
    int pravac; //0 - svuda, 1 - desno, 2 - dole
    int d;
};

queue<polje> q1;
queue<polje> q2;
polje tmp;

int main()
{
    int n, m, a, b;
    scanf("%d%d%d%d", &n, &m, &a, &b);
    for(int i = 0; i < n; i++) {
        scanf("%s", &s);
        for(int j = 0; j < m; j++) {
            resV[i][j] = 0;
            resH[i][j] = 0;
            if(s[j] == '1') {
                mat[i][j] = true;
                resV[i][j] = -1;
                resH[i][j] = -1;
            } else {
                mat[i][j] = false;
                tmp.i = i; tmp.j = j; tmp.pravac = 0; tmp.d = 1;
                q1.push(tmp);
                q2.push(tmp);
            }
        }
    }

    int i, j, pravac, d;
    int barbosa = 0;
    while(!q1.empty()) {
        tmp = q1.front();
        i = tmp.i;
        j = tmp.j;
        pravac = tmp.pravac;
        d = tmp.d;
        //printf("%d %d %d %d\n", i, j, pravac, d);
        q1.pop();

        if((pravac == 0 || pravac == 1) && j + 1 < m && !mat[i][j + 1]) {
            if(d + 1 == b) {
                barbosa++;
                for(int k = j + 1; k >= j - b + 2; k--)
                    resH[i][k]++;
            } else {
                tmp.i = i;
                tmp.j = j + 1;
                tmp.pravac = 1;
                tmp.d = d + 1;
                q1.push(tmp);
            }
        }

        if((pravac == 0 || pravac == 2) && i + 1 < n && !mat[i + 1][j]) {
            if(d + 1 == b) {
                barbosa++;
                for(int k = i + 1; k >= i - b + 2; k--)
                    resV[k][j]++;
            } else {
                tmp.i = i + 1;
                tmp.j = j;
                tmp.pravac = 2;
                tmp.d = d + 1;
                q1.push(tmp);
            }
        }
    }

    int sol = -1;
    int jack;
    while(!q2.empty()) {
        tmp = q2.front();
        i = tmp.i;
        j = tmp.j;
        pravac = tmp.pravac;
        d = tmp.d;
        //printf("%d %d %d %d\n", i, j, pravac, d);
        q2.pop();

        if((pravac == 0 || pravac == 1) && j + 1 < m && !mat[i][j + 1]) {
            if(d + 1 == a) {
                jack = -1;
                for(int k = j + 1; k >= j - a + 2; k--)
                    jack = max(jack, resH[i][k]);
                for(int k = j + 1; k >= j - a + 2; k--)
                    jack += resV[i][k];
                sol = max(sol, jack);
            } else {
                tmp.i = i;
                tmp.j = j + 1;
                tmp.pravac = 1;
                tmp.d = d + 1;
                q2.push(tmp);
            }
        }

        if((pravac == 0 || pravac == 2) && i + 1 < n && !mat[i + 1][j]) {
            if(d + 1 == a) {
                jack = -1;
                for(int k = i + 1; k >= i - a + 2; k--)
                    jack = max(jack, resV[k][j]);
                for(int k = i + 1; k >= i - a + 2; k--)
                    jack += resH[k][j];
                sol = max(sol, jack);
            } else {
                tmp.i = i + 1;
                tmp.j = j;
                tmp.pravac = 2;
                tmp.d = d + 1;
                q2.push(tmp);
            }
        }
    }

    /*for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if(resV[i][j] == -1)
                printf("%d ", resV[i][j]);
            else
                printf(" %d ", resV[i][j]);
        }
        printf("\n");
    }

    printf("\n");

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if(resH[i][j] == -1)
                printf("%d ", resH[i][j]);
            else
                printf(" %d ", resH[i][j]);
        }
        printf("\n");
    }*/

    printf("%d", barbosa - sol);
    return 0;
}
/*
5 6 3 3
110111
000001
000001
111101
100010

2 5 2 5
00000
00000
*/