#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long eval (vector< int > A, vector< int > B) {
    int a = 1, b = 1;
    long long sol = 0;
    while (a <= 6) {
        if (A[a] > B[b]) {
            A[a] -= B[b];
            if (a > b) {
                sol += B[b];
            }
            b++;
        }
        else if (A[a] < B[b]) {
            B[b] -= A[a];
            if (a > b) {
                sol += B[b];
            }
            a++;
        }

        else {
            if (a > b) {
                sol += B[b];
            }
            a++;
            b++;
        }
    }
    return sol;
}

int main()
{
    int n, i;
    cin >> n;
    vector< int > x (2 * n);

    for (i = 0; i < 2*n; i++) {
        cin >> x[i];
    }

    long long msol = 0;
    vector< int > A(7, 0), B(7, 0);

    A[x[0]]++;
    B[x[1]]++;
    msol = max(msol, eval(A, B));
    for (i = 2; i <= n; i++) {
        //cout << s1 << " " << s2 << " " << i-1 << endl;
        //s1 += x[i-1];
        //s2 = s2 - x[i-1] + x[2*(i-1)] + x[2*i-1];

        A[x[i-1]]++;
        B[x[i-1]]--;
        B[x[2*(i-1)]]++;
        B[x[2*i-1]]++;

        msol = max(msol, eval(A, B));
    }
    /*
    for (i = 1; i <= 6; i++) {
        cout << A[i] << " ";
    }
    cout << endl;
    for (i = 1; i <= 6; i++) {
        cout << B[i] << " ";
    }
    cout << endl;*/
    cout << msol;
}
/*
4
2 4 6 1 5 3 5 2

2
1 1 2 2

*/