#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long eval (vector< int > A, vector< int > B) {
    int a = 1, b = 1;
    long long sol = 0;
    while (a <= 6 && b <= 6) {
        if (A[a] > B[b]) {
            A[a] -= B[b];
            if (a > b) {
                sol += B[b];
            }
            b++;
        }
        else if (A[a] < B[b]) {
            B[b] -= A[a];
            if (a > b) {
                sol += A[a];
            }
            a++;
        }

        else {
            if (a > b) {
                sol += B[b];
            }
            a++;
            b++;
        }
    }
    return sol;
}

int main()
{
    cin.sync_with_stdio(false);
    cin.tie(NULL);

    int n, i;
    cin >> n;
    vector< int > x (2 * n);

    for (i = 0; i < 2*n; i++) {
        cin >> x[i];
    }

    long long msol = 0;
    vector< int > A(7, 0), B(7, 0);

    A[x[0]]++;
    B[x[1]]++;
    msol = max(msol, eval(A, B));
    for (i = 2; i <= n; i++) {
        A[x[i-1]]++;
        B[x[i-1]]--;
        B[x[2*(i-1)]]++;
        B[x[2*i-1]]++;

        msol = max(msol, eval(A, B));
    }

    cout << msol;
}