#include <iostream>
#include <map>
#include <vector>
#include <cmath>

#define divisor pair< int, bool >

using namespace std;

int main()
{
    cin.sync_with_stdio(false);
    cin.tie(NULL);

    vector< divisor > div;
    div.push_back(divisor (1, true));

    int n, k;
    cin >> n >> k;
    vector< int > s(n);

    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }

    for (int i = 2; i <= sqrt(n); i++) {
        if (n % i == 0) {
            div.push_back(divisor (i, true));
            div.push_back(divisor (n/i, true));
        }
    }

    div.push_back(divisor (n, true));

    int sol = 1;

    for (int i = 1; i < div.size(); i++) {
        if (div[i].first < k) {
            sol++;
        }
        else if (div[i].second) {
            bool valid = true;
            int d = div[i].first;

            for (int j = 0; j < n / d; j++) {
                map< int, int > m;

                int maximum = 0, maxin;
                for (int l = 0; l < d; l++) {
                    m[s[j*d + l]]++;
                    //cout << s[j*d + l] << " " << m[s[j*d + l]] << endl;
                    if (m[s[j*d + l]] > maximum) {
                        maximum = m[s[j*d + l]];

                        if (maximum > k) {
                            valid = false;
                            for (int l = i; l < div.size(); l++) {
                                if (div[l].first % d == 0) {
                                    div[l].second = false;
                                }
                            }
                            break;
                        }
                    }
                }
                if (!valid) {
                    break;
                }
            }

            if (valid) {
                sol++;
            }
        }
    }

    cout << sol;
}