#include <cstdio>

void quickSort(int *arr, long long left, long long right);

int main()
{
    long long n, rez = 0, i, j, r1, r2, razlika = -1000, komb = 0;
    scanf("%lld", &n);
    long long d = n*2, dojava[d];
    for (i = 0; i < d; i++)
        scanf("%lld",&dojava[i]);
    for (i = 1; i < n+1; i++) {
        r1 = r2 = 0;
        for (j = 0; j < i; j++) {
            r1 += dojava[j];
            r2 += dojava[j+i];
        }
        if (r1-r2 > razlika) {
            razlika = r1-r2;
            komb = i;
        }
    }
    int arr1[komb], arr2[komb];
    for (j = 0; j < komb; j++) {
        arr1[j] = dojava[j];
        arr2[j] = dojava[j+komb];
    }
    quickSort(arr1, 0, j-1);
    quickSort(arr2, 0, j-1);
    for (i = 0; i < j; i++) {
        if (arr1[i] > arr2[i])
            rez++;
    }
    printf("%lld",rez);
    return 0;
}

void quickSort(int *arr, long long left, long long right)
{
    long long i = left, j = right;
    int pivot = arr[(left+right)/2], tmp;
    while (i <= j) {
        while (arr[i] < pivot)
            i++;
        while (arr[j] > pivot)
            j--;
        if (i <= j) {
            tmp = arr[j];
            arr[j] = arr[i];
            arr[i] = tmp;
            i++;
            j--;
        }
    }
    if (j > left)
        quickSort(arr, left, j);
    if (i < right)
        quickSort(arr, i, right);
}