#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>

using namespace std;

int occurances (int arr[], int from, int to, int num)
{
    int value = 0;
    for (int i = from; i < to; i++)
        if (arr[i] == num) value++;
    return value;
}

int main()
{
    ios::sync_with_stdio(false);

    int n, k, fails = 0;
    cin >> n >> k;
    int stick[n];

    for (int i = 0; i < n; i++)
    {
        cin >> stick[i];
    }
    int root = floor(sqrt(n));
    vector<int> divs;
    for (int i = 1; i <= root; i++)
    {
        if (n / i == (int)(n / i))
        {
            divs.push_back(n / i);
            divs.push_back(i);
        }
    }
    for (size_t i = 0; i < divs.size(); i++)
    {
        int div = divs[i];
        bool good = true;
        for (int j = 0; j < n / div; j++)
        {
            for (int s = j * div; s < (j + 1) * div; s++)
                if (occurances(stick, j * div, (j + 1) * div, stick[s]) > k)
                {
                    good = false;
                    fails++;
                    break;
                }
            if (good == false) break;
        }
    }
    cout << divs.size() - fails;

    return 0;
}