#include <iostream>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <cmath>

#define SET_SIZE 400'009
#define MAXN 100'000

using namespace std;

unordered_set<int> t(SET_SIZE);
unordered_set<int> f(SET_SIZE);

int ans[MAXN];

unordered_map<int, vector<int>> w(SET_SIZE);
unordered_map<int, vector<int>> c(SET_SIZE);

int isPrime(int n) {
    for(int i=2; i<=sqrt(n); i++)
        if(n%i == 0)
            return 0;
    return 1;
}

int main()
{
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    int q; string a;
    for(int i=0; i<n; i++) {
        cin >> q >> a;
        if(a[0] == 'd') {
            t.insert(q);
        } else {
            f.insert(q);
        }
        ans[i] = q;
    }
    for(int i=0; i<n; i++) {
        if(t.find(ans[i]) != t.end() && f.find(ans[i]) != f.end()) {
            auto pos = c.find(ans[i]);
            if(pos == c.end()) {
                vector<int> v(0);
                v.push_back(i+1);
                c.insert(make_pair(ans[i], v));
            } else {
                (*pos).second.push_back(i+1);
            }
        } else {
            auto pos = w.find(ans[i]);
            if(pos == w.end()) {
                vector<int> v(0);
                v.push_back(i+1);
                w.insert(make_pair(ans[i], v));
            } else {
                (*pos).second.push_back(i+1);
            }
        }
    }

    for(int i=1; i<=n; i++) {
        bool f = true;
        for(auto ci = c.begin(); ci != c.end(); ci++) {
            int cnt = 0;
            vector<int> v = (*ci).second;
            for(auto vi = v.begin(); vi != v.end(); vi++)
                if((*vi)%i == 0)
                    cnt++;
            if(cnt != (v.size()-1)) {
                f = false;
                break;
            }
        }
        if(!f) continue;
        for(auto wi = w.begin(); wi != w.end(); wi++) {
            int cnt = 0;
            vector<int> v = (*wi).second;
            for(auto vi = v.begin(); vi != v.end(); vi++)
                if((*vi)%i == 0)
                    cnt++;
            if(cnt != 0 && cnt != v.size()) {
                f = false;
                break;
            }
        }
        if(f) {
            cout << i;
            return 0;
        }
    }
    cout << -1;
    return 0;
    return 0;
}